Skip to main content Skip to footer

Creating a Heat Map Visualization with FlexMap and ColorScale in JavaScript

Wijmo FlexMap Heat Map

Background:

Wijmo does not currently provide a dedicated built-in HeatMap chart type. However, you can simulate a heat map by using the FlexMap control with ColorScale.

This approach works by rendering each heat map cell as a GeoJSON polygon and using ColorScale to assign colors based on each cell’s value.

Steps to Complete:

  1. Install and import the required Wijmo packages.
  2. Add a host element for the heat map.
  3. Create heat map data.
  4. Convert the data into GeoJSON polygons.
  5. Configure FlexMap, GeoMapLayer, and ColorScale.

Getting Started:

Install and import the required Wijmo packages

npm install @mescius/wijmo.purejs.all

Then import the required modules:

import '@mescius/wijmo.styles/wijmo.css';
import { FlexMap, GeoMapLayer, ColorScale } from '@mescius/wijmo.chart.map';
import { Position } from '@mescius/wijmo.chart';
  • FlexMap displays the visualization, GeoMapLayer renders the generated shapes, and ColorScale applies colors based on the data value.

 

Add a host element for the heat map

Add a container where the heat map will render.

<div id="heatMap"></div>

Add a height so the map has visible space on the page:

#heatMap {
  height: 420px;
  width: 100%;
}

 

Create heat map data

Define the row, column, and value for each heat map cell.

const heatData = [
  { region: 'North', quarter: 'Q1', value: 24 },
  { region: 'North', quarter: 'Q2', value: 38 },
  { region: 'North', quarter: 'Q3', value: 65 },
  { region: 'North', quarter: 'Q4', value: 42 },
  { region: 'South', quarter: 'Q1', value: 18 },
  { region: 'South', quarter: 'Q2', value: 55 },
  { region: 'South', quarter: 'Q3', value: 72 },
  { region: 'South', quarter: 'Q4', value: 49 }
];

const rows = [...new Set(heatData.map(item => item.region))];
const columns = [...new Set(heatData.map(item => item.quarter))];
  • Each object represents one heat map cell. The value field is what determines the cell color.

 

Convert the data into GeoJSON polygons

GeoMapLayer uses GeoJSON, so each heat map cell can be represented as a rectangular polygon.

function createHeatMapGeoJson(data, rows, columns) {
  return {
    type: 'FeatureCollection',
    features: data.map(item => {
      const x = columns.indexOf(item.quarter);
      const y = rows.indexOf(item.region);

      return {
        type: 'Feature',
        properties: item,
        geometry: {
          type: 'Polygon',
          coordinates: [[
            [x, y],
            [x + 1, y],
            [x + 1, y + 1],
            [x, y + 1],
            [x, y]
          ]]
        }
      };
    })
  };
}
  • This creates one polygon for each data point. The polygon’s properties object keeps the original value available for color binding and tooltips.

 

Configure FlexMap, GeoMapLayer, and ColorScale

Create the map, add a GeoMapLayer, and use ColorScale.binding to read each cell’s value.

const heatMapGeoJson = createHeatMapGeoJson(heatData, rows, columns);

let heatMap = new FlexMap('#heatMap', {
  header: 'Sales Heat Map',
  legend: {
    position: Position.Right
  },
  tooltip: {
    content: feature => {
      const item = feature.properties;
      return `${item.region}<br>${item.quarter}: ${item.value}`;
    }
  },
  layers: [
    new GeoMapLayer({
      itemsSource: heatMapGeoJson,
      style: {
        stroke: '#ffffff',
        strokeWidth: 1
      },
      colorScale: new ColorScale({
        binding: feature => feature.properties.value,
        colors: ['#2166ac', '#67a9cf', '#f7f7f7', '#fdae61', '#b2182b'],
        colorUnknown: '#eeeeee',
        format: 'n0'
      }),
      itemsSourceChanged: layer => {
        heatMap.zoomTo(layer.getGeoBBox());
      }
    })
  ]
});
  • ColorScale transforms each numeric value into a color. Lower values are displayed with cooler colors, and higher values are displayed with warmer colors.

 

With this setup, FlexMap displays a heat map-style visualization, and ColorScale automatically colors each cell based on the bound value.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Creating a Heat Map Visualization with FlexMap and ColorScale in Angular

FlexMap Heat Map

Background:

Wijmo does not currently provide a dedicated built-in heat map chart type. However, in Angular applications, you can create a heat map-style visualization by using the Wijmo FlexMap control with GeoMapLayer and ColorScale.

This approach renders each heat map cell as a GeoJSON polygon. The ColorScale component then applies colors to each cell based on its numeric value.

Steps to Complete:

  1. Install and import the Wijmo Angular packages.
  2. Add the Wijmo CSS.
  3. Create the heat map data in the Angular component.
  4. Convert the data into GeoJSON polygons.
  5. Add the Wijmo Angular map markup.
  6. Configure the color scale and tooltip.

Getting Started:

Install and import the Wijmo Angular packages

npm install @mescius/wijmo.angular2.chart.map @mescius/wijmo.angular2.chart @mescius/wijmo.styles
  • The chart.map package provides the Angular components for FlexMap, GeoMapLayer, and ColorScale. The chart package is used for the legend component.

 

Add the Wijmo CSS

In styles.css, import the Wijmo stylesheet.

@import '@mescius/wijmo.styles/wijmo.css';
  • This loads the default styles required by Wijmo controls.

 

Create the heat map data in the Angular component

In app.component.ts, import the Angular map and chart modules.

import { Component } from '@angular/core';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
import {
  WjChartMapModule,
  WjFlexMap,
  WjGeoMapLayer
} from '@mescius/wijmo.angular2.chart.map';
import { Position } from '@mescius/wijmo.chart';
  • WjChartMapModule enables the map components, and WjChartModule enables the legend component used inside the map.
interface HeatMapItem {
  region: string;
  quarter: string;
  value: number;
}

export class AppComponent {
  readonly legendPosition = Position.Right;

  readonly heatData: HeatMapItem[] = [
    { region: 'North', quarter: 'Q1', value: 24 },
    { region: 'North', quarter: 'Q2', value: 38 },
    { region: 'North', quarter: 'Q3', value: 65 },
    { region: 'North', quarter: 'Q4', value: 42 },
    { region: 'South', quarter: 'Q1', value: 18 },
    { region: 'South', quarter: 'Q2', value: 55 },
    { region: 'South', quarter: 'Q3', value: 72 },
    { region: 'South', quarter: 'Q4', value: 49 }
  ];

  readonly rows = [...new Set(this.heatData.map(item => item.region))];
  readonly columns = [...new Set(this.heatData.map(item => item.quarter))];
}
  • Each item represents one heat map cell. The value field is used by ColorScale to determine the cell color.

 

Convert the data into GeoJSON polygons

Add the following helper method and properties to the component.

readonly heatColors = ['#2166ac', '#67a9cf', '#f7f7f7', '#fdae61', '#b2182b'];

readonly cellStyle = {
  stroke: '#ffffff',
  strokeWidth: 1
};

readonly heatMapGeoJson = this.createHeatMapGeoJson();

getHeatValue = (feature: any): number => {
  return feature.properties.value;
};

private createHeatMapGeoJson() {
  return {
    type: 'FeatureCollection',
    features: this.heatData.map(item => {
      const x = this.columns.indexOf(item.quarter);
      const y = this.rows.indexOf(item.region);

      return {
        type: 'Feature',
        properties: item,
        geometry: {
          type: 'Polygon',
          coordinates: [[
            [x, y],
            [x + 1, y],
            [x + 1, y + 1],
            [x, y + 1],
            [x, y]
          ]]
        }
      };
    })
  };
}
  • The GeoMapLayer requires GeoJSON data, so each heat map cell is represented as a rectangular polygon.

 

Add the Wijmo Angular map markup

In app.component.html, add the wj-flex-map, wj-geo-map-layer, and wj-color-scale components.

<wj-flex-map
  #heatMap
  [header]="'Sales Heat Map'"
  (initialized)="initMap(heatMap)">

  <wj-flex-chart-legend [position]="legendPosition"></wj-flex-chart-legend>

  <wj-geo-map-layer
    #layer
    [itemsSource]="heatMapGeoJson"
    [style]="cellStyle"
    (itemsSourceChanged)="fitHeatMap(layer)">

    <wj-color-scale
      [binding]="getHeatValue"
      [colors]="heatColors"
      [colorUnknown]="'#eeeeee'"
      [format]="'n0'">
    </wj-color-scale>

  </wj-geo-map-layer>
</wj-flex-map>
  • The map renders the GeoJSON polygons, and the color scale colors each polygon according to the value returned by getHeatValue.

 

Configure the color scale and tooltip

Add these methods to app.component.ts.

initMap(map: WjFlexMap): void {
  map.tooltip.content = (feature: any) => {
    const item = feature.properties;
    return `${item.region}<br>${item.quarter}: ${item.value}`;
  };
}

fitHeatMap(layer: WjGeoMapLayer): void {
  if (layer.map) {
    layer.map.zoomTo(layer.getGeoBBox());
  }
}
  • The tooltip displays the region, quarter, and value for each cell. The fitHeatMap method zooms the map to the generated heat map area after the layer is bound.

 

Add Component Styles

In app.component.css, give the map a visible height.

wj-flex-map {
  display: block;
  width: 100%;
  height: 420px;
}

 

With this setup, the Angular application uses Wijmo FlexMap, GeoMapLayer, and ColorScale to create a heat map-style visualization from standard data.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Creating a Heat Map Visualization with FlexMap and ColorScale in React

FlexMap heat map

Background:

Wijmo does not currently provide a dedicated built-in HeatMap chart type. However, in React applications, you can create a heat map-style visualization by using Wijmo’s FlexMap, GeoMapLayer, and ColorScale components.

This approach renders each heat map cell as a GeoJSON polygon. The ColorScale component then applies colors to each cell based on its numeric value.

Steps to Complete:

  1. Install the required packages.
  2. Import Wijmo React components.
  3. Create the heat map data.
  4. Convert the data into GeoJSON polygons.
  5. Render the map with React components.

Getting Started:

Install the required packages

npm install @mescius/wijmo.react.chart.map @mescius/wijmo.react.chart @mescius/wijmo.styles
  • The chart.map package provides React components for FlexMap, GeoMapLayer, and ColorScale. The chart package provides the legend component.

 

Import Wijmo React components

import { useCallback, useMemo } from 'react';
import '@mescius/wijmo.styles/wijmo.css';

import { FlexChartLegend } from '@mescius/wijmo.react.chart';
import { FlexMap, GeoMapLayer, ColorScale } from '@mescius/wijmo.react.chart.map';
import { Position } from '@mescius/wijmo.chart';
  • These imports allow the map, map layer, legend, and color scale to be declared directly in JSX.

 

Create the heat map data

const heatData = [
  { region: 'North', quarter: 'Q1', value: 24 },
  { region: 'North', quarter: 'Q2', value: 38 },
  { region: 'North', quarter: 'Q3', value: 65 },
  { region: 'North', quarter: 'Q4', value: 42 },
  { region: 'South', quarter: 'Q1', value: 18 },
  { region: 'South', quarter: 'Q2', value: 55 },
  { region: 'South', quarter: 'Q3', value: 72 },
  { region: 'South', quarter: 'Q4', value: 49 }
];
  • Each object represents one heat map cell. The value field determines the color assigned by ColorScale.

 

Convert the data into GeoJSON polygons

function createHeatMapGeoJson(data, rows, columns) {
  return {
    type: 'FeatureCollection',
    features: data.map(item => {
      const x = columns.indexOf(item.quarter);
      const y = rows.indexOf(item.region);

      return {
        type: 'Feature',
        properties: item,
        geometry: {
          type: 'Polygon',
          coordinates: [[
            [x, y],
            [x + 1, y],
            [x + 1, y + 1],
            [x, y + 1],
            [x, y]
          ]]
        }
      };
    })
  };
}
  • GeoMapLayer expects GeoJSON data, so each heat map cell is represented as a rectangular polygon.

 

Render the map with React components

const heatColors = ['#2166ac', '#67a9cf', '#f7f7f7', '#fdae61', '#b2182b'];
const cellStyle = { stroke: '#ffffff', strokeWidth: 1 };
const mapHostStyle = { width: '100%', height: '420px' };

export default function App() {
  const rows = useMemo(() => [...new Set(heatData.map(item => item.region))], []);
  const columns = useMemo(() => [...new Set(heatData.map(item => item.quarter))], []);

  const heatMapGeoJson = useMemo(() => {
    return createHeatMapGeoJson(heatData, rows, columns);
  }, [rows, columns]);

  const getHeatValue = useCallback(feature => {
    return feature.properties.value;
  }, []);

  const initMap = useCallback(map => {
    map.tooltip.content = feature => {
      const item = feature.properties;
      return `${item.region}<br>${item.quarter}: ${item.value}`;
    };
  }, []);

  const fitHeatMap = useCallback(layer => {
    if (layer.map) {
      layer.map.zoomTo(layer.getGeoBBox());
    }
  }, []);

  return (
    <FlexMap
      header="Sales Heat Map"
      initialized={initMap}
      style={mapHostStyle}
    >
      <FlexChartLegend position={Position.Right} />

      <GeoMapLayer
        itemsSource={heatMapGeoJson}
        style={cellStyle}
        itemsSourceChanged={fitHeatMap}
      >
        <ColorScale
          binding={getHeatValue}
          colors={heatColors}
          colorUnknown="#eeeeee"
          format="n0"
        />
      </GeoMapLayer>
    </FlexMap>
  );
}
  • The FlexMap component renders the visualization, GeoMapLayer displays the generated GeoJSON cells, and ColorScale colors each cell according to its bound value.

  • The initialized callback configures the tooltip, while itemsSourceChanged zooms the map to the generated heat map area after the layer is bound.

Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Creating a Heat Map Visualization with FlexMap and ColorScale in Vue

FlexMap heat map

Background:

Wijmo does not currently provide a dedicated built-in HeatMap chart type. However, in Vue applications, you can create a heat map-style visualization by using Wijmo’s FlexMap, GeoMapLayer, and ColorScale components.

This approach renders each heat map cell as a GeoJSON polygon. The ColorScale component then applies colors to each cell based on its numeric value.

Steps to Complete:

  1. Install and import the Wijmo Vue packages.
  2. Create the heat map data.
  3. Convert the data into GeoJSON polygons.
  4. Render the map with Vue markup.
  5. Configure the color scale, tooltip, and map bounds.

Getting Started:

Install and import the Wijmo Vue packages

npm install @mescius/wijmo.vue2.chart.map @mescius/wijmo.vue2.chart @mescius/wijmo.chart @mescius/wijmo.styles
  • The chart.map package provides Vue components for FlexMap, GeoMapLayer, and ColorScale. The chart package provides the legend component.
<script setup>
import { computed } from 'vue';
import '@mescius/wijmo.styles/wijmo.css';

import { WjFlexChartLegend } from '@mescius/wijmo.vue2.chart';
import {
  WjFlexMap,
  WjGeoMapLayer,
  WjColorScale
} from '@mescius/wijmo.vue2.chart.map';
import { Position } from '@mescius/wijmo.chart';
</script>
  • Wijmo Vue components can be used directly in the template when imported in a Vue single-file component using <script setup>.

 

Create the heat map data

<script setup>
const heatData = [
  { region: 'North', quarter: 'Q1', value: 24 },
  { region: 'North', quarter: 'Q2', value: 38 },
  { region: 'North', quarter: 'Q3', value: 65 },
  { region: 'North', quarter: 'Q4', value: 42 },
  { region: 'South', quarter: 'Q1', value: 18 },
  { region: 'South', quarter: 'Q2', value: 55 },
  { region: 'South', quarter: 'Q3', value: 72 },
  { region: 'South', quarter: 'Q4', value: 49 }
];

const rows = computed(() => [...new Set(heatData.map(item => item.region))]);
const columns = computed(() => [...new Set(heatData.map(item => item.quarter))]);
</script>
  • Each object represents one heat map cell. The value field determines the color assigned by ColorScale.

 

Convert the data into GeoJSON polygons

<script setup>
function createHeatMapGeoJson(data, rows, columns) {
  return {
    type: 'FeatureCollection',
    features: data.map(item => {
      const x = columns.indexOf(item.quarter);
      const y = rows.indexOf(item.region);

      return {
        type: 'Feature',
        properties: item,
        geometry: {
          type: 'Polygon',
          coordinates: [[
            [x, y],
            [x + 1, y],
            [x + 1, y + 1],
            [x, y + 1],
            [x, y]
          ]]
        }
      };
    })
  };
}

const heatMapGeoJson = computed(() => {
  return createHeatMapGeoJson(heatData, rows.value, columns.value);
});
</script>
  • GeoMapLayer expects GeoJSON data, so each heat map cell is represented as a rectangular polygon.

 

Render the map with Vue markup.Configure the color scale, tooltip, and map bounds

<template>
  <wj-flex-map
    class="heat-map"
    header="Sales Heat Map"
    :initialized="initMap"
  >
    <wj-flex-chart-legend :position="legendPosition" />

    <wj-geo-map-layer
      :items-source="heatMapGeoJson"
      :style="cellStyle"
      :items-source-changed="fitHeatMap"
    >
      <wj-color-scale
        :binding="getHeatValue"
        :colors="heatColors"
        color-unknown="#eeeeee"
        format="n0"
      />
    </wj-geo-map-layer>
  </wj-flex-map>
</template>
  • The wj-flex-map component renders the visualization, wj-geo-map-layer displays the generated GeoJSON cells, and wj-color-scale colors each cell according to its bound value.
<script setup>
const legendPosition = Position.Right;
const heatColors = ['#2166ac', '#67a9cf', '#f7f7f7', '#fdae61', '#b2182b'];
const cellStyle = { stroke: '#ffffff', strokeWidth: 1 };

function getHeatValue(feature) {
  return feature.properties.value;
}

function initMap(map) {
  map.tooltip.content = feature => {
    const item = feature.properties;
    return `${item.region}<br>${item.quarter}: ${item.value}`;
  };
}

function fitHeatMap(layer) {
  if (layer.map) {
    layer.map.zoomTo(layer.getGeoBBox());
  }
}
</script>
  • The initialized handler configures the tooltip. The itemsSourceChanged handler zooms the map to the generated heat map area after the layer is bound.
<style>
.heat-map {
  display: block;
  width: 100%;
  height: 420px;
}
</style>

 

With this setup, the Vue application uses Wijmo FlexMap, GeoMapLayer, and ColorScale to create a heat map-style visualization from standard data.

Happy coding!

Andrew Peterson

Technical Engagement Engineer